<template>
    <app-layout>
        <div class="row justify-content-center">
            <div class="col-lg-6">
                <h1 class="h2 mb-3">Server Settings</h1>
                
                <form @submit.prevent="form.patch(route('server.settings.update'))">
                    <form-field text="Server Name" id="inputServerName" :errors="form.errors.serverName" v-slot="slotProps">
                        <form-input v-model="form.serverName" v-bind="slotProps" />
                    </form-field>
                    
                    <form-field text="Server Address" description="Used to get server status and filter API requests." :errors="[form.errors.serverAddress, form.errors.serverPort]" id="inputServerAddress" v-slot="slotProps">
                        <form-input v-model="form.serverAddress" v-bind="slotProps" :error="slotProps.error[0]" placeholder="127.0.0.1" />
                        <form-text>:</form-text>
                        <form-input v-model="form.serverPort" :error="slotProps.error[1]" placeholder="7240" />
                    </form-field>
                    
                    <form-field text="API Key" id="inputAPIKey" :errors="form.errors.serverApiKey" v-slot="slotProps">
                        <form-input v-model="form.serverApiKey" v-bind="slotProps" />
                    </form-field>
                    
                    <form-checkbox-field>
                        <form-checkbox id="inputAPIConnection" v-model="form.serverApiInscure">Allow API connections from any IP address</form-checkbox>
                        <form-checkbox id="inputAPICloudflare" v-model="form.serverApiCloudflare">Web server is behind cloudflare</form-checkbox>
                    </form-checkbox-field>
                    
                    <form-field text="Welcome Message" description="{s0} = player name
{s1} = player last active date
{s2} = player k/d ratio
{reg4} = player kills
{reg5} = player deaths
{reg6} = player teamkills
{reg7} = player global rank
{reg8} = player GUID" id="inputWelcome" :errors="form.errors.serverWelcome" v-slot="slotProps">
                        <form-textarea v-model="form.serverWelcome" v-bind="slotProps" rows="5" />
                    </form-field>
                    
                    <form-list-input :ordered="true" text="Announcements" :list="form.serverAnnouncements" :errors="form.errors" errorPrefix="serverAnnouncements" />
                    
                    <form-button :disabled="form.processing">Save Changes</form-button>
                </form>
            </div>
        </div>
    </app-layout>
</template>

<script>
    import { useForm } from '@inertiajs/inertia-vue3'
    import AppLayout from '@/Layouts/AppLayout'
    import FormInput from '@/Components/Form/FormInput'
    import FormField from '@/Components/Form/FormField'
    import FormText from '@/Components/Form/FormText'
    import FormButton from '@/Components/Form/FormButton'
    import FormCheckboxField from '@/Components/Form/FormCheckboxField'
    import FormCheckbox from '@/Components/Form/FormCheckbox'
    import FormTextarea from '@/Components/Form/FormTextarea'
    import FormListInput from '@/Components/Form/FormListInput'

    
    export default {
        props: {
            'settings': Array,
        },
        
        components: {
            AppLayout,
            FormInput,
            FormField,
            FormText,
            FormButton,
            FormCheckboxField,
            FormCheckbox,
            FormTextarea,
            FormListInput,
        },
        
        mounted() {
            for (const setting of this.settings) {
                this.form[setting['setting']] = setting['value'];
            }
        },
        
        setup () {
            const form = useForm({
                serverName: null,
                serverAddress: null,
                serverPort: null,
                serverApiKey: null,
                serverApiInscure: false,
                serverApiCloudflare: false,
                serverWelcome: null,
                serverAnnouncements: [],
                // serverAnnouncementList: ['a','b'],
            })

            return { form }
        },
    }
</script>